import os
from uuid import uuid4
from datetime import datetime
from PIL import Image
import os
import tempfile
from moviepy import VideoFileClip
import cv2
import tempfile

def post_image_upload_to(instance, filename):
    ext = os.path.splitext(filename)[-1].lower()
    unique_filename = f"{datetime.now().strftime('%Y%m%d%H%M%S')}_{uuid4().hex}{ext}"
    return f"profiles/{instance.post.user.id}_{instance.post.user.username}/posts/images/{unique_filename}"

def post_thumbnail_upload_to(instance, filename):
    ext = os.path.splitext(filename)[-1].lower()
    unique_filename = f"{datetime.now().strftime('%Y%m%d%H%M%S')}_{uuid4().hex}{ext}"
    return f"profiles/{instance.post.user.id}_{instance.post.user.username}/posts/thumbnail/{unique_filename}"

def post_video_upload_to(instance, filename):
    ext = os.path.splitext(filename)[-1].lower()
    unique_filename = f"{datetime.now().strftime('%Y%m%d%H%M%S')}_{uuid4().hex}{ext}"
    # return f"profiles/{instance.user.id}_{instance.user.username}/posts/videos/{unique_filename}"
    return f"profiles/{instance.post.user.id}_{instance.post.user.username}/posts/videos/{unique_filename}"

def headshot_upload_to(instance, filename):
    ext = os.path.splitext(filename)[-1].lower()
    unique_filename = f"{datetime.now().strftime('%Y%m%d%H%M%S')}_{uuid4().hex}{ext}"
    return f"profiles/{instance.user.id}_{instance.user.username}/headshots/{unique_filename}"

def generate_video_thumbnail(video_file):
    temp_thumb = tempfile.NamedTemporaryFile(suffix=".jpg", delete=False)
    cap = cv2.VideoCapture(video_file.temporary_file_path())
    success, frame = cap.read()
    if success:
        resized_frame = cv2.resize(frame, (300, 300))  # Resize to a 300x300 thumbnail
        cv2.imwrite(temp_thumb.name, resized_frame)
    cap.release()
    return temp_thumb.name

